'''Game main module.

Contains the entry point used by the run_game.py script.

Feel free to put all your game code here, or in other modules in this "gamelib"
package.
'''
import pyglet
import cocos
import gameplay
from pyglet import font
import pyglet.window.key as KEY
import pyglet
import cocos
from cocos.layer.base_layers import *
import gameplay
from ccreader import *
from cocos.scenes import *
import os
import configparser

class MainScreen(Layer):
    is_event_handler = True

    def __init__(self, scene):
        super(MainScreen, self).__init__()
        scene.add(self)
        score_text = scene.node_dict["best_score"][0]
        score_text.visible = False
        self.scene_done = False
        config = configparser.ConfigParser()
        try: 
            config.read('score.ini')
            if config.has_option("best", "score"):
                score_text.element.text = config.get("best", "score")
                score_text.visible = True
        except:
            pass

    def on_key_release (self, key, modifiers):        
        if not (key == KEY.ENTER):
            return
        if self.scene_done:
            return
        self.scene_done = True
        self.start_gameplay()

    def on_mouse_press(self, x, y, d, f):
        if self.scene_done:
            return
        self.scene_done = True
        self.start_gameplay()
    
    def start_gameplay(self):
        scn = gameplay.CreateScene()
        cocos.director.director.replace(FadeTransition(scn, duration=0.5))
        #cocos.director.director.run(scn)

def CreateScene():
    cr = CreatorReader()
    scene = cr.LoadScene(os.path.join("Scene", "main.ccreator"))
    scene.add(MainScreen(scene))
    return scene

def main():
    pyglet.resource.path.append(os.path.join("Resources", "creator"))
    pyglet.resource.reindex()
    # font.add_file(os.path.join("Resources", "creator", "5b3c4000-e1a8-497f-ae3c-21658b84f67f", "SAMAN___.ttf"))
    cocos.director.director.init(width=960, height=640, autoscale=False)
    scn = CreateScene()
    cocos.director.director.run(scn)
    

